<?php
namespace App\Controllers;


class Promoter extends BaseController{


    public function __construct()  
    { 
    

          $this->db = \Config\Database::connect(); 
    } 

public function my_pin_request(){

    $promoterId = session()->get('id');
            $stockist = $this->request->getPost('pin_stockist');
            $no_of_pins = $this->request->getPost('no_of_pin');
            $scheme = $this->request->getPost('scheme');
            $payment_status = $this->request->getPost('payment_status');
            $remarks = $this->request->getPost('remarks');
            $requestId = "RI" . str_pad(rand(10000000, 99999999), 8, '0', STR_PAD_LEFT);

            
   $builder=$this->db->table('promoter_requests');
   
    $data=[
        "stockist"=>$stockist,
        "scheme"=>$scheme,
        "promoter_id"=>$promoterId,
        "request_id"=>$requestId,
        "total_slots"=>$no_of_pins,
        "payment_status"=>$payment_status ,
        "remarks"=>$remarks,
        "created_at" => date('Y-m-d H:i:s'),
        'status' => 'Pending'
        
        ];
        
        
       if( $builder->insert($data)){
        return $this->response->setJSON(['result' => 1, 'message' => 'insert successfully']);
           
       }
       else{
      return $this->response->setJSON(['result' => 1, 'message' => 'Failed to add']);
       }
}


public function create_customer() {
     $promoterId = session()->get('id');

    $scheme = $this->request->getPost('scheme');
    $name = $this->request->getPost('name');
    $email = $this->request->getPost('email');
    $mobile = $this->request->getPost('mobile');
    $state = $this->request->getPost('state');
    $city = $this->request->getPost('city');
    $pincode = $this->request->getPost('pincode');
    $address = $this->request->getPost('address');
    $card_no = $this->request->getPost('card_no');

    // Fetch available promoter request
    $request = $this->db->table('promoter_requests')
                        ->where('promoter_id', $promoterId) // Adjust as needed for dynamic promoter_id
                        ->where('status', 'Approved')
                        ->where('used_slots < total_slots')
                        ->orderBy('created_at', 'ASC') 
                        ->get()
                        ->getRow();

    if (!$request) {
        return $this->response->setJSON(['result' => 0, 'message' => 'No available request ID. Please contact the admin.']);
    }

    $requestId = $request->request_id;

    // Generate a unique user ID (could be a simple increment or a more complex approach like UUID)
    $userId = 'UID'. rand(1000, 9999); 

    // Insert customer data
    $builder = $this->db->table('Customers');

    $data = [
        'user_id' => $userId, // Adding the generated user ID
        'scheme' => $scheme,
        'name' => $name,
        'email' => $email,
        'mobile' => $mobile,
        'state' => $state,
        'city' => $city,
        'pincode' => $pincode,
        'address' => $address,
        'card_no' => $card_no,
        'request_id' => $requestId,
        'promoter_id' =>$promoterId, // Adjust as needed for dynamic promoter_id
        'created_at' => 'NOW()',
        


    ];

    // Insert data into the Customers table
    if ($builder->insert($data)) {
        // Update the promoter_requests table first to increment used slots
        $this->db->table('promoter_requests')
                 ->where('id', $request->id)
                 ->update(['used_slots' => $request->used_slots + 1]);

        // Return success response
        return $this->response->setJSON([
            'result' => 1,
            'message' => "User registered successfully with Request ID $requestId and User ID $userId"
        ]);
    } else {
        // Return failure response
        return $this->response->setJSON([
            'result' => 0,
            'message' => 'Failed to register'
        ]);
    }
}


public function customers_detail_list(){
    

    try {
        
        $builder = $this->db->table('Customers');
        $builder->orderBy('created_at', 'DESC');
        $query = $builder->get();

        $data = $query->getResult();

        if ($data) {
            return $this->response->setJSON($data);
        } else {
            return $this->response->setJSON(['result' => 0, 'message' => 'Failed to load data']);
        }
    } catch (\Exception $e) {
      
        return $this->response->setJSON(['result' => 0, 'message' => $e->getMessage()]);
    }

}


public function get_customer_details(){
    
     $customerId = $this->request->getGet('id');


    $customer = $this->db->table('Customers')
                         ->where('id', $customerId)
                         ->get()
                         ->getRow();

    if ($customer) {

        return $this->response->setJSON([
            'result' => 1,
            'data' => $customer
        ]);
    } else {
        return $this->response->setJSON([
            'result' => 0,
            'message' => 'Customer not found.'
        ]);
    }
}


public function pin_request_list(){
       $promoterId = session()->get('id');
    try {


        $builder = $this->db->table('promoter_requests');
        
  
        $builder->select('promoter_requests.*');
        
        //$builder->join('Customers', 'Customers.request_id = promoter_requests.request_id','inner');
   
        $builder->where('promoter_requests.promoter_id',$promoterId );
     
        //$builder->groupBy('promoter_requests.request_id');
  
        $query = $builder->get();

        $data = $query->getResult();
//   print_r($data);die();
        if ($data) {
    
            return $this->response->setJSON($data);
          
        } else {
           
            return $this->response->setJSON(['result' => 0, 'message' => 'No data available']);
        }
    } catch (\Exception $e) {
     
        return $this->response->setJSON(['result' => 0, 'message' => 'Error: ' . $e->getMessage()]);
    }
}


//   wriiten by dileep

 <?php

namespace App\Controllers;

use CodeIgniter\Controller;

class CustomerController extends Controller
{
    // This function is responsible for fetching the filtered customer details
    public function getFilteredCustomerDetails()
    {
        // Get 'fromDate' and 'toDate' from the request
        $fromDate = $this->request->getGet('fromDate');
        $toDate = $this->request->getGet('toDate');

        // Connect to the database
        $db = \Config\Database::connect();
        $builder = $db->table('Customers');

        // Join with the 'user' table to get the promoter name
        $builder->join('user', 'user.id = Customers.promoter_id', 'left');

        // Apply the date filter if both dates are provided
        if ($fromDate && $toDate) {
            // Convert dates to Y-m-d format
            $fromDate = date('Y-m-d', strtotime($fromDate));
            $toDate = date('Y-m-d', strtotime($toDate));

            // Add where conditions for date range
            $builder->where('Customers.created_at >=', $fromDate)
                    ->where('Customers.created_at <=', $toDate);
        }

        // Select the relevant columns including the promoter's name
        $builder->select('Customers.id, Customers.name, Customers.user_id, Customers.scheme, Customers.card_no, Customers.created_at, user.name as promoter_name');

        // Execute the query to fetch the data
        $query = $builder->get();
        $customers = $query->getResultArray();

        // Return the result as JSON
        return $this->response->setJSON($customers);
    }

    // This function is responsible for fetching the details of a single customer by ID
    public function getCustomerDetails()
    {
        // Get the customer ID from the request
        $customerId = $this->request->getGet('id');

        // Connect to the database
        $db = \Config\Database::connect();
        $builder = $db->table('Customers');

        // Fetch the customer by ID
        $query = $builder->getWhere(['id' => $customerId]);
        $customer = $query->getRowArray();

        // Check if the customer exists
        if ($customer) {
            return $this->response->setJSON(['result' => 1, 'data' => $customer]);
        } else {
            return $this->response->setJSON(['result' => 0, 'message' => 'Customer not found']);
        }
    }
}


?>