<?php echo view('includes/sidebar'); ?>
<script type="text/javascript" src="<?php echo base_url('public/assets/js/jquery-3.6.0.min.js'); ?>"></script>
<script src="<?php echo base_url('public/assets/toastr/toastr.min.js');?>"></script>


<link rel="stylesheet" href="<?php echo base_url('public/assets/toastr/toastr.min.css');?>">
<link rel="stylesheet" href="https://cdn.datatables.net/1.11.5/css/jquery.dataTables.min.css">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.11.5/js/jquery.dataTables.min.js"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css" rel="stylesheet">


<style>
/* Reduce table margin and padding */
.dataTables_wrapper {
    margin: 10px auto; /* Smaller margin */
    width: 95%; /* Adjust width for a compact layout */
}

/* Style table */
#datatable {
    border: 1px solid #ddd;
    border-radius: 5px;
    font-size: 14px; /* Adjust font size */
    background-color: #fff;
}

/* Header styling */
#datatable thead {
    background-color: #f4f4f4;
    color: #333;
    font-weight: bold;
    border-bottom: 2px solid #ccc;
}

/* Row styling */
#datatable tbody tr {
    border-bottom: 1px solid #ddd;
}

#datatable tbody tr:hover {
    background-color: #f9f9f9; /* Highlight on hover */
}

/* Action buttons */
.crud--buttons .btn {
    margin: 0 5px; /* Small spacing between buttons */
    font-size: 12px; /* Smaller font for buttons */
    padding: 5px 10px; /* Compact button size */
    border-radius: 3px;
}

/* Eye icon button */
.view--butt {
    color: #fff;
    background-color: #17a2b8; /* Bootstrap 'info' color */
    border: none;
}

/* Menu icon button */
.menu--butt {
    color: #fff;
    background-color: #6c757d; /* Bootstrap 'secondary' color */
    border: none;
}

/* Icon sizes */
.fas {
    font-size: 14px;
    vertical-align: middle;
}

/* Serial number column */
#datatable td:first-child {
    text-align: center;
    font-weight: bold;
}
</style>

<section class="home-section fullpage">
    <div class="home-content">
        <i class='bx bx-menu'></i>
        <!-- <span class="text">Drop Down Sidebar</span> -->
    </div>


    <!-- heading row   -->
    <div class="row m-0">
        <div class="col-sm-12">
            <h1 class="crt-pjt">Customer Reports</h1>
        </div>
    </div>

    <!-- form row  -->
    <!-- forms -->
   <!-- Date Range Filter -->
<form id="dateFilterForm" >
    <label for="fromDate">From Date:</label>
    <input type="date" id="fromDate" name="fromDate" required>

    <label for="toDate">To Date:</label>
    <input type="date" id="toDate" name="toDate" required>

    <button type="submit" id="filterBtn">Filter</button>
</form>



<table id="datatable" class="table table-striped table-bordered">
    <thead>
        <tr>
            <th>SL No</th>
            <th>ID</th>
            <th>Name</th>
            <th>User Id</th>
            <th>Scheme</th>
            <th>Card Number</th>
            <th>Promoter Name</th>
            <th>Created At</th>
            <th>Actions</th>
        </tr>
    </thead>
    <tbody></tbody>
</table>

</section>


<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/datatables.net/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/datatables.net-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.10.8/dist/sweetalert2.all.min.js"></script>


<script>
$(document).ready(function () {
    var table = $('#datatable').DataTable({
        pageLength: 20,
        ajax: {
            url: '<?php echo base_url("getFilteredCustomerDetails"); ?>',
            data: function(d) {
                // Capture the selected dates and send them with the request
                var fromDate = $('#fromDate').val();
                var toDate = $('#toDate').val();
                
                if (fromDate) d.fromDate = fromDate;
                if (toDate) d.toDate = toDate;
            },
            dataSrc: function(json) {
                return json;
            },
            error: function() {
                alert('Error fetching data.');
            }
        },
        columns: [
            { data: null },
            { data: 'id', visible: false },
            { data: 'name' },
            { data: 'user_id' },
            { data: 'scheme' },
            { data: 'card_no' },
            { data: 'promoter_name' }, // Display Promoter Name
            {
                data: 'created_at',
                render: function(data) {
                    var date = new Date(data);
                    var day = ("0" + date.getDate()).slice(-2);
                    var month = ("0" + (date.getMonth() + 1)).slice(-2);
                    var year = date.getFullYear().toString();
                    var hours = ("0" + date.getHours()).slice(-2);
                    var minutes = ("0" + date.getMinutes()).slice(-2);
                    return day + '-' + month + '-' + year + ' ' + hours + ':' + minutes;
                }
            },
            {
                data: null,
                render: function(data, type, row) {
                    return '<button class="btn btn-info" onclick="view(' + row.id + ')">View</button>';
                }
            }
        ],
        rowCallback: function(row, data, index) {
            $('td:eq(0)', row).html(index + 1);  // Serial number column
        },
        language: {
            emptyTable: "No data available"
        }
    });

    // Trigger filtering on form submission
    $('#dateFilterForm').on('submit', function(e) {
        e.preventDefault();  // Prevent form submission (page reload)
        table.ajax.reload();  // Reload the DataTable with new filters
    });

    // View customer details
    window.view = function(customerId) {
        $.ajax({
            url: '<?php echo base_url("getCustomerDetails"); ?>',
            type: 'GET',
            data: { id: customerId },
            success: function(response) {
                if (response.result === 1) {
                    // Show customer details in modal
                    $('#customerModal').html(
                        '<div>' +
                            '<p>Name: ' + response.data.name + '</p>' +
                            '<p>Email: ' + response.data.email + '</p>' +
                            '<p>Mobile: ' + response.data.mobile + '</p>' +
                            '<p>Address: ' + response.data.address + '</p>' +
                            '<p>Card No: ' + response.data.card_no + '</p>' +
                            '<p>State: ' + response.data.state + '</p>' +
                            '<p>City: ' + response.data.city + '</p>' +
                            '<p>Pincode: ' + response.data.pinCode + '</p>' +
                        '</div>'
                    );
                    $('#customerModal').show();
                } else {
                    alert('Failed to fetch customer details.');
                }
            },
            error: function() {
                alert('Error fetching customer data.');
            }
        });
    };
});
</script>



























<script>
    let arrow = document.querySelectorAll(".arrow");
    for (var i = 0; i < arrow.length; i++) {
        arrow[i].addEventListener("click", (e) => {
            let arrowParent = e.target.parentElement.parentElement;
            arrowParent.classList.toggle("showMenu");
        });
    }
    let sidebar = document.querySelector(".sidebar");
    let sidebarBtn = document.querySelector(".bx-menu");
    console.log(sidebarBtn);
    sidebarBtn.addEventListener("click", () => {
        sidebar.classList.toggle("close");
    });
</script>



<?php echo view('includes/footer'); ?>














